<!-- <p-table
  [value]="posts" 
  [loading]="loading"
  [rows]="30" 
  [showCurrentPageReport]="true"
  [scrollable]="true" scrollHeight="flex"
  dataKey="id"
  >
  <ng-template pTemplate="caption">
    <button pButton pRipple label="New Post" icon="pi pi-plus" class="p-button-success mr-2" (click)="openNew()"></button>
  </ng-template>

  <ng-template pTemplate="header">
    <tr>
      <th pSortableColumn="headline">Headline
        <p-sortIcon field="headline"></p-sortIcon>
      </th>
      <th pSortableColumn="text">Text
        <p-sortIcon field="text"></p-sortIcon>
      </th>
      <th pSortableColumn="date">Date
        <p-sortIcon field="date"></p-sortIcon>
      </th>
      <th>Actions</th>
    </tr>
  </ng-template>
  <ng-template pTemplate="body" let-post let-editing="editing" let-ri="rowIndex">
    <tr [pEditableRow]="post">
      <td>{{ post.headline }}</td>
      <td>
        {{ post.text }}
      </td>
      <td>{{ post.date }}</td>
      <td class="posts-actions">
        <button pButton type="button" icon="pi pi-eye" (click)="showPost(post)" class="p-button-rounded p-button-text"></button>
        <button pButton pRipple type="button" icon="pi pi-pencil" (click)="openEdit(post)" class="p-button-rounded p-button-text"></button>
        <button pButton pRipple icon="pi pi-trash" class="p-button-rounded p-button-danger p-button-text" (click)="deletePost(post)"></button>
      </td>
    </tr>
  </ng-template>
</p-table> -->

<div *ngIf="isAdmin" class="new-post-container">
  <button pButton pRipple label="New Post" icon="pi pi-plus" class="p-button-success mr-2" (click)="openNew()"></button>
</div>
<div class="posts-container" *ngIf="posts">
  <!-- <ng-container *ngFor="let post of posts; trackBy: trackById" >
    <p-card [header]="post.headline" [subheader]="post.date">
      <span class="post-text">{{ post.text }} </span>
      <ng-template pTemplate="footer">
        <p-button (click)="openEdit(post)" label="Edit" icon="pi pi-pencil"></p-button>
        <p-button (click)="deletePost(post)" label="Delete" icon="pi pi-times" styleClass="p-button-danger" [style]="{ 'margin-left': '.5em' }"></p-button>
      </ng-template>
    </p-card>
  </ng-container> -->

  <cdk-virtual-scroll-viewport itemSize="20" class="viewport">
    <ng-container *cdkVirtualFor="let post of posts; trackBy: trackById" >
      <p-card [header]="post.headline" [subheader]="post.date">
        <!-- <p class="post-text">
            {{ post.text }} 
        </p> -->
        <span class="post-text">{{ post.text }} </span>
        <ng-template *ngIf="isAdmin" pTemplate="footer">
          <p-button (click)="openEdit(post)" label="Edit" icon="pi pi-pencil"></p-button>
          <p-button (click)="deletePost(post)" label="Delete" icon="pi pi-times" styleClass="p-button-danger" [style]="{ 'margin-left': '.5em' }"></p-button>
        </ng-template>
      </p-card>
    </ng-container>
  </cdk-virtual-scroll-viewport>

</div>

<p-dialog [(visible)]="postDialog" [style]="{ width: '450px' }" [header]="actionMode + ' post'" [modal]="true" styleClass="p-fluid">
  <ng-template pTemplate="content">
      <div class="field">
          <label for="headline">Headline</label>
          <input [disabled]="actionMode === ActionMode.VIEW" type="text" pInputText id="headline" [(ngModel)]="newPost.headline" required autofocus />
          <small class="p-error" *ngIf="submitted && !newPost.headline">Headline is required.</small>
      </div>
      <div class="field">
        <label for="text">Text</label>
        <textarea [disabled]="actionMode === ActionMode.VIEW" rows="5" cols="30" pInputTextarea [(ngModel)]="newPost.text"></textarea>
        <small class="p-error" *ngIf="submitted && !newPost.text">Text is required.</small>
      </div>
  </ng-template>

  <ng-template pTemplate="footer">
      <button pButton pRipple label="Cancel" icon="pi pi-times" class="p-button-text" (click)="hideDialog()"></button>
      <button *ngIf="actionMode !== ActionMode.VIEW" pButton pRipple label="Save" icon="pi pi-check" class="p-button-text" (click)="savePost()"></button>
  </ng-template>
</p-dialog>

<p-toast [breakpoints]="{'768px': {width: '90%'}}"></p-toast>
<p-confirmDialog [breakpoints]="{'768px': 'unset'}" [style]="{width: '50vw'}"></p-confirmDialog>